# frozen_string_literal: true
#
# Model concern to provide shared behaviour for two-factor auth (one-time password)
#
# Automatically generated by the orthodox gem (https://github.com/katanacode/orthodox)
# (c) Copyright 2019 Katana Code Ltd. All Rights Reserved. 
module Otpable
  extend ActiveSupport::Concern
  
  included do
    
    has_one :otp_credential, as: :authable  
    
    delegate :valid_otp?, :valid_recovery_code?, to: :otp_credential
    
  end
  
  def tfa?
    otp_credential.present?
  end
    
  def destroy_otp_credential
    otp_credential.destroy
  end
  
end