# frozen_string_literal: true
#
# Helpers for automating sign-in and out during tests
# Automatically generated by the orthodox gem (https://github.com/katanacode/orthodox)
# (c) Copyright 2019 Katana Code Ltd. All Rights Reserved. 
#
module AuthenticationHelpers
  def sign_in(record, **options)
    type = record.class.model_name.singular
    visit(public_send("new_#{type.pluralize}_session_path"))
    fill_in :"#{type}_session_email", with: record.email
    fill_in :"#{type}_session_password", with: record.password
    click_button "Sign in"
  end
end
RSpec.configure do |config|
  config.include(AuthenticationHelpers, type: :system)
end